<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <style>
        body {
            font-family: Arial, Helvetica, sans-serif;
        }

        /* The Modal (background) */
        .modal {
            display: none;
            /* Hidden by default */
            position: fixed;
            /* Stay in place */
            z-index: 1;
            /* Sit on top */
            padding-top: 100px;
            /* Location of the box */
            left: 0;
            top: 0;
            width: 100%;
            /* Full width */
            height: 100%;
            /* Full height */
            overflow: auto;
            /* Enable scroll if needed */
            background-color: rgb(0, 0, 0);
            /* Fallback color */
            background-color: rgba(0, 0, 0, 0.4);
            /* Black w/ opacity */
        }

        /* Modal Content */
        .modal-content {
            background-color: #fefefe;
            margin: auto;
            padding: 20px;
            border: 1px solid #888;
            width: 80%;
        }

        /* The Close Button */
        .close {
            color: #aaaaaa;
            float: right;
            font-size: 28px;
            font-weight: bold;
        }

        .close:hover,
        .close:focus {
            color: #000;
            text-decoration: none;
            cursor: pointer;
        }
    </style>
</head>

<body>

    <h2>Modal Example</h2>

    <!-- Trigger/Open The Modal -->
    <button id="myBtn" data-target="myModal">Open Modal</button>

    <!-- The Modal -->
    <div id="myModal" class="modal">
        <!-- Modal content -->
        <div class="modal-content">
            <span class="close">&times;</span>
            <p>Some text in the Modal..</p>
        </div>
    </div>

    <!- Напишите код, который: 1. Показывает всплывающее окно myModal через секунду после загрузки страницы. 2.
        Закрывает его спустят 2 секунды после показа. 3. При клике на кнопку показывает его спустя 500 мс. 4. При клике
        на крестик - закрывает его спустят 300 мс. Код должен быть максимально универсальным. --->
        <script>
            
            const clickBtn = document.getElementById("myBtn");
            clickBtn.addEventListener('click', function () {
                const modalId = this.dataset.target;
                setTimeout(() => {
                    const modal = document.getElementById(modalId);
                    modal.style.display = 'block';
                }, 500);

            });
            const closeModal = document.querySelectorAll(".modal .close");
            closeModal.forEach(function (btnClose) {
                btnClose.addEventListener("click", function () {
                    const modal = this.closest(".modal");
                    setTimeout(() => {
                        modal.style.display = 'none';

                    }, 500);
                });
            });
            const modalWindow = document.getElementsByClassName("modal");
            for (let i = 0; i < modalWindow.length; i++) {
                modalWindow[i].addEventListener("click", function (e) {
                    console.log(e.taget);

                    if(!e.target.closest('modal-content')){
                        
                        this.style.display = 'none';

                    }
                });
            }
        </script>
</body>

</html>